import React, { CSSProperties } from 'react';
import { SwiperContextProps } from '../../hooks';
export declare const SwiperContext: React.Context<SwiperContextProps>;
declare function Swiper(props: SwiperProps): JSX.Element;
declare namespace Swiper {
    var displayName: string;
}
interface SlideImageProps {
    src: string;
    alt?: string;
    title?: string;
    transition?: EffectType;
    parentDisplayName: `Swiper` | `Link`;
    onClick?: () => void;
}
export interface VariablesRefProps {
    currentSlide: number;
    currentImage: SlideImageProps;
    totalSlides: number;
    running: boolean;
    paused: boolean;
    stop: boolean;
    controlNavEl: boolean;
}
export declare type EffectType = 'random' | `fade` | `fold` | `sliceDown` | `sliceDownRight` | `sliceDownLeft` | `sliceUp` | `sliceUpRight` | `sliceUpLeft` | `sliceUpDown` | `sliceUpDownLeft` | `sliceUpDownRight` | `slideInRight` | `slideInLeft` | `boxRandom` | `boxRain` | `boxRainReverse` | `boxRainGrow` | `boxRainGrowReverse`;
export interface SwiperProps {
    theme?: `default` | `light` | `dark` | `bar`;
    effect?: EffectType;
    slices?: number;
    boxCols?: number;
    boxRows?: number;
    animSpeed?: number;
    pauseTime?: number;
    startSlide?: number;
    directionNav?: boolean;
    controlNav?: boolean;
    controlNavThumbs?: boolean;
    pauseOnHover?: boolean;
    manualAdvance?: boolean;
    prevText?: string;
    nextText?: string;
    randomStart?: boolean;
    beforeChange?: () => void;
    afterChange?: () => void;
    slideshowEnd?: () => void;
    lastSlide?: () => void;
    afterLoad?: () => void;
    children: React.ReactNode;
    className?: string;
    style?: CSSProperties;
}
export default Swiper;
